"""Command line client functionality, broken into a separate file
so it can be more easily tested."""

from __future__ import absolute_import
from nilmdb.printf import *
import nilmdb.client

import time
import sys
import re
import os
import urlparse
from optparse import OptionParser, OptionGroup, OptionValueError

version = "0.1"

def parse_opts(args):
    parser = OptionParser(usage="usage: %prog [options]",
                          version="nilmdb client script %prog " + version)
    parser.add_option("-q", "--quiet", action="store_true", default=False,
                      dest="quiet", help="suppress unnecessary console output")
    group = OptionGroup(parser, "Server")
    group.add_option("-u", "--url", action="store", dest="url",
                     default="http://localhost:12380/",
                     help="NilmDB server URL (default: %default)")
    parser.add_option_group(group)

    (opt, rest) = parser.parse_args(args)

    return (opt, rest)

def run(args):
    (opt, rest) = parse_opts(args)

    if not opt.quiet:
        printf("Server URL: %s\n", opt.url)
