# Misc fixes and tools

# Workaround for cherrypy bug #1131:
# This is a wrapper for the cherrypy.request.rfile object
# that fixes the __iter__() and readline() routines
import cherrypy.wsgiserver
class FixChunkedRFile(object):
    def __init__(self, rfile):
        if not isinstance(rfile,
                          cherrypy.wsgiserver.ChunkedRFile): # pragma: no cover
            raise TypeError("bugfix wrapper is specific to ChunkedRFile")
        self.rfile = rfile

    def readline(self):
        data = ""
        while True:
            if not self.rfile.buffer:
                self.rfile._fetch()
                if not self.rfile.buffer:
                    return data
            newline_pos = self.rfile.buffer.find('\n')
            if newline_pos == -1:
                data += self.rfile.buffer
                self.rfile.buffer = ""
            else:
                data += self.rfile.buffer[:newline_pos+1]
                self.rfile.buffer = self.rfile.buffer[newline_pos+1:]
                return data

    def __iter__(self):
        line = self.readline()
        while line:
            yield line
            line = self.readline()
